from models.item import Item
from materials.abstract_material import AbstractMaterial
from rares.metal_seams import MetalSeams
from rares.shabby import Shabby

from text.comments import print_irony


class Wall(Item):
    def __init__(self, material: type[AbstractMaterial] = AbstractMaterial) -> None:
        self.name = "Стена"
        self.description = "Обычная стена орбитальная станции, которую вы бы могли видеть у себя в каюте"

        self.rares = [Shabby, MetalSeams]
        self.material = material
        self.health = 1000 * self.material.health_multiplier
        self.scale = 100

    def take(self) -> None:
        Item.take(self, success=False)
        print_irony()
